#ifndef __VBL610__
#define __VBL610__

#include "wavelet.h"

invertlowFunc invertlow3_c;
inverthighFunc inverthigh3_c;
transformFunc transform3_c;

extern "C" { 
extern transformFunc transform3_3dne;//, transform3_sse;
extern invertlowFunc invertlow3_3dne;//, invertlow3_sse;
extern inverthighFunc inverthigh3_3dne;//, inverthigh3_sse;
}

class VBL610 : public Wavelet {
public:
	VBL610(int x, int y, int n);
	_inline void transform2d (float *input, int hsize, int vsize, int nsteps);
	_inline void invert2d (float *input, int hsize, int vsize, int nsteps);
	_inline void invert_step(float register* input, float register* output,
							 int size);
	_inline void transform_step(float register* input, float register* output,
								int size, int lowSize);
	_inline void symmetric_extension(float *output, int size, int left_ext, int right_ext);
	_inline void antisymmetric_extension(float *output, int size,  int left_ext,int right_ext);
};

class VBL610_3DNowExt : public VBL610
{
public:
	VBL610_3DNowExt(int x, int y, int n) : VBL610(x ,y, n)
	{
		Transform = transform3_3dne; // v0.35
//		Transform = transform3_c;
		InvertLow = invertlow3_3dne;
//		InvertLow = invertlow3_c;
//		InvertHigh = inverthigh3_c;
		InvertHigh = inverthigh3_3dne;
	};
};

class VBL610_3DNow : public VBL610
{
public:
	VBL610_3DNow(int x, int y, int n) : VBL610(x ,y, n)
	{
		Transform = transform3_3dne;// v0.35
//		Transform = transform3_c;
		InvertLow = invertlow3_c;
		InvertHigh = inverthigh3_c;
	};
};

class VBL610_SSE : public VBL610
{
public:
	VBL610_SSE(int x, int y, int n) : VBL610(x ,y, n)
	{
		Transform = transform3_c;
		InvertLow = invertlow3_c;
		InvertHigh = inverthigh3_c;
	};
};

class VBL610_C : public VBL610
{
public:
	VBL610_C(int x, int y, int n) : VBL610(x ,y, n)
	{
		Transform = transform3_c;
		InvertLow = invertlow3_c;
		InvertHigh = inverthigh3_c;
	};
};

#endif